

//https://www.brainy-bits.com/dht11-tutorial/
//http://www.circuitbasics.com/wp-content/uploads/2015/11/SRD-05VDC-SL-C-Datasheet.pdf
#include <dht.h>
#include <LiquidCrystal_I2C.h>
#include <math.h>

dht DHT;
int pinOut = 2;
LiquidCrystal_I2C lcd(0x3F, 20, 4); // Set the LCD address to 0x3F

void setup() {
  Serial.begin(9600);
  lcd.begin();
  lcd.backlight();
  lcd.print("****Initializing****");
  delay(200);
  //lcd.clear();
  pinMode(6, INPUT);
  pinMode(2, OUTPUT);

}

void loop() {
  
    
    displayAmbient();
   //Serial.println(getButtonPressed());
   photoResistor();
}
void displayAmbient(){
    DHT.read11(6);
    printSensorDataLCD();
 
    
    delay(2000);//Wait 2 seconds before accessing sensor again.
}
 int getWaterLevel(){
  return analogRead(A0);
 }
 int getHumidity(){
 // DHT.read11(6);
  return DHT.humidity;
 }
 int getTempC(){
  int temp;
  temp = DHT.temperature;
    return temp;
 }
 int getTempF(){
  int temp;
  temp = DHT.temperature;
    temp= temp*9/8;
    temp = temp +32;
    return temp;
 }
 void printSensorData(){
    Serial.print("Water Level = ");
    Serial.print(getWaterLevel());
    Serial.print("  Current humidity = ");
    Serial.print(getHumidity());
    Serial.print("%  ");
    Serial.print("temperature = ");
    Serial.print(getTempF()); 
    Serial.println("F  ");
 }
 void printSensorDataLCD(){
    int tempMode = 0;
    lcd.clear();
    lcd.setCursor(0,0);
    lcd.print("Water Level = ");
    lcd.print(getWaterLevel());
    lcd.setCursor(0,1);
    lcd.print("Humidity = ");
    lcd.print(getHumidity());
    lcd.print("%  ");
    lcd.setCursor(0,2);
    lcd.print("Temperature = ");
    if(getButtonPressed().equals("UP")){
      tempMode = 0;
    } else if (getButtonPressed().equals("DOWN")){
      tempMode = 1;
    }

    if (tempMode == 0){
      lcd.print(getTempC());
      lcd.print("C");
    }else if (tempMode == 1){
      lcd.print(getTempF());
      lcd.print("F");
    }
 }
 String getButtonPressed(){
  String button = "";
  if(analogRead(A1) >100){
    button = "UP";
  }
  else if(analogRead(A2) >100){
    button = "DOWN";
  }
  else if(analogRead(A3) >100){
    button = "SELECT";
  }
  else{
    button = "";
  }
  return button;
 }
 void printButtonStates(){
    Serial.print(analogRead(A1));
    Serial.print("  -   ");
    Serial.print(analogRead(A2));
    Serial.print("  -   ");
    Serial.println(analogRead(A3));
 }

double Thermistor(int RawADC) {
 double Temp;
 Temp = log(10000.0*((1024.0/RawADC-1))); 
 Temp = 1 / (0.001129148 + (0.000234125 + (0.0000000876741 * Temp * Temp ))* Temp );
 Temp = Temp - 273.15;          
 Temp = (Temp * 9.0)/ 5.0 + 32.0; 
 return Temp;
}
void photoResistor(){ //runs pump as long as there is light
  int val;                
  double light;            
  val=analogRead(A4);      
  light=lightCalc(val);   
  Serial.print("Light = ");
  Serial.print(light);   
  Serial.println(" I");
  if (light >= 350){
    digitalWrite(pinOut, HIGH);
  }
  else if (getWaterLevel() >200){
    digitalWrite(pinOut, HIGH);
  }else if(getButtonPressed().equals("SELECT")){
    digitalWrite(pinOut, HIGH);
  }
  else {
    digitalWrite(pinOut, LOW);
  }
  delay(500);            
}
double lightCalc(int RawADC) {
 double Temp;
 Temp = log(10000.0*((1024.0/RawADC-1))); 
 Temp = 1 / (0.001129148 + (0.000234125 + (0.0000000876741 * Temp * Temp ))* Temp );
 Temp = Temp - 273.15;          
 Temp = (Temp * 9.0)/ 5.0 + 32.0; 
 return Temp;
}

